/**
 * @file
 * Visual styles for form components.
 */

form .field-multiple-table {
  margin: 0;
}
form .field-multiple-table .field-multiple-drag {
  width: 30px;
  padding-right: 0;
}
form .field-multiple-table .field-multiple-drag .tabledrag-handle {
  padding-right: 0.5em;
}
form .field-add-more-submit {
  margin: 0.5em 0 0;
}


/* ----- Forms and groups ----- */

form {
  margin-block: 0;
  padding-block: 0;
}

/* Fieldsets match boxes */
fieldset:not(.fieldgroup, .glb-form-wrapper) {
  margin-inline: 0;
  padding-block: 2.5rem;
  padding-inline: 2.5rem;
  border: none;
  background-color: var(--color-alt-background);
}
.alt-back fieldset:not(.fieldgroup, .glb-form-wrapper) {
  background-color: var(--color-background);
}

fieldset:not(.fieldgroup, .glb-form-wrapper) > legend {
  display: contents;
  margin: 0;
  padding: 0;
}
fieldset:not(.fieldgroup, .glb-form-wrapper) > legend > .fieldset-legend {
  display: block;
  margin-block: 0 2rem;
  margin-inline: 0;
  padding: 0;
  font-weight: var(--font-weight-bold);
  font-size: var(--font-size-plus-4);
}

fieldset:not(.fieldgroup, .glb-form-wrapper) > .fieldset-wrapper {
  margin-trim: block;
}
fieldset:not(.fieldgroup, .glb-form-wrapper) > .fieldset-wrapper > *:first-child,
fieldset:not(.fieldgroup, .glb-form-wrapper) > .fieldset-wrapper > *:first-child > *:first-child {
  margin-block-start: 0;
}
fieldset:not(.fieldgroup, .glb-form-wrapper) > .fieldset-wrapper > *:last-child,
fieldset:not(.fieldgroup, .glb-form-wrapper) > .fieldset-wrapper > *:last-child > *:last-child {
  margin-block-end: 0;
}


/* Optional no indent (for nested fieldsets) */
fieldset.no-indent:not(.fieldgroup, .glb-form-wrapper) {
  padding: 0;
}


/* Nested fieldsets */
fieldset:not(.fieldgroup, .glb-form-wrapper) fieldset:not(.fieldgroup, .glb-form-wrapper) > legend > .fieldset-legend {
  font-size: var(--font-size-plus-2);
}


/* ----- Form fields ----- */

.form-item,
.form-actions,
fieldset.webform-composite-hidden-title {
  margin-block: 1em 1.6em;
}

tr.odd .form-item,
tr.even .form-item {
  margin-block: 0;
}

.form-composite > .fieldset-wrapper > .description,
.form-item .description {
  clear: both;
  margin-block: 0.25em 0.75em;
  line-height: var(--font-lineheight-shorter);
  color: var(--color-text-light);
  font-size: var(--font-size-smaller-2);
  font-weight: var(--font-weight-text);
}
.form-item label + .description {
  margin-block: 0.4em 0.6em;
}


.form-composite > legend,
.label {
  display: inline;
  margin: 0;
  padding: 0;
  font-size: inherit;
  font-weight: var(--font-weight-label);
}

/* Checkbox/radio button labels */
label.option {
  display: inline;
  font-weight: normal;
  vertical-align: middle;
}
label:not(.option) {
  clear: both;
  display: block;
  margin-block-end: 0.25em;
  color: var(--color-text-dark);
  font-weight: var(--font-weight-label);
  line-height: var(--font-lineheight-shortest);
}

.form-checkboxes .form-item,
.form-radios .form-item {
  margin-top: 0.4em;
  margin-bottom: 0.4em;
}

.form-type-radio .description,
.form-type-checkbox .description {
  margin-left: 2.4em;
}

.marker {
  color: #e00;
}

.form-required::after {
  display: inline-block;
  width: 6px;
  height: 6px;
  margin: 0 0.3em;
  content: "";
  vertical-align: super;
  /* Use a background image to prevent screen readers from announcing the text. */
  background-image: url("../../images/icons/required.svg");
  background-repeat: no-repeat;
  background-size: 6px 6px;
}

abbr.tabledrag-changed,
abbr.ajax-changed {
  border-bottom: none;
}

.form-item input.error,
.form-item textarea.error,
.form-item select.error {
  border: 2px solid red;
}


/* Inline error messages. */
.form-item--error-message::before {
  display: inline-block;
  width: 14px;
  height: 14px;
  content: "";
  vertical-align: sub;
  background: url("../../images/icons/error.svg") no-repeat;
  background-size: contain;
}


/* Scroll snap validation errors below sticky header */
input:invalid,
select:invalid,
textarea:invalid {
  scroll-margin-top: var(--sticky-header-offset, 0px);
}

/* Other radio buttons */
input[type="checkbox"]:not(.glb-form-checkbox) + label,
input[type="radio"]:not(.glb-form-radio) + label {
  clear: none;
  display: inline-block;
}
.form-checkboxes input[type="checkbox"]:not(.glb-form-checkbox) + label,
.form-checkboxes input[type="radio"]:not(.glb-form-radio) + label { /* Fix wrapping for lists of multiple checkboxes */
  display: inline;
}


:is(input, select, textarea):not(.glb-form-element, .glb-button) {
  font: 1em/var(--font-lineheight-shorter) var(--font-family-text);
  color: var(--gray-9);
  vertical-align: middle;
}

input:is(.form-text, [type="text"], [type="email"], [type="search"], [type="tel"], [type="password"]):not(.glb-form-element) {
  inline-size: auto;
  max-inline-size: calc(100% - 1.5rem - 2px);
  margin-inline-start: 0;
  padding: 0.5em 0.75em;
  border: 1px solid var(--color-field-border);
  border-radius: 0.25rem;
  background-color: var(--color-background);
}

select {
  block-size: 2.4rem;
  inline-size: calc(100% - 2px);
  border: 1px solid var(--color-field-border);
  border-radius: 0.25rem;
  background-color: var(--color-background);
}

@media (max-width: 767px) {
  /* Stretch full width on mobile */
  input:is(.form-text, [type="text"], [type="email"], [type="search"], [type="tel"], [type="password"]):not(.glb-form-element) {
    inline-size: calc(100% - 1.5rem - 2px);
  }
  select:not(.glb-form-element) {
    inline-size: 100%;
  }

  /* Unless it has a prefix */
  .field-prefix + input:is(.form-text, [type="text"], [type="email"], [type="search"], [type="tel"], [type="password"]):not(.glb-form-element) {
    inline-size: auto;
  }
}

textarea:not(.glb-form-element) {
  inline-size: calc(100% - 2rem - 2px);
  padding: 1rem;
  border: 1px solid var(--color-field-border);
  border-radius: 0.25rem;
}

input.form-text[readonly],
textarea[readonly],
select[readonly] {
  color: var(--gray-6);
}
span.form-required:not(.fieldset-legend) {
  color: #ffae00;
}


/* Submit buttons (minimal change in dark mode) */
input:is(.form-submit, [type="submit"]):not(.glb-button) {
  -webkit-appearance: none;
  appearance: none;
  position: relative;
  display: inline-block;
  margin: 0;
  padding-block: 0.6875em;
  padding-inline: 1.5em;
  cursor: pointer;
  border: 1px solid var(--gray-4);
  border-radius: 0;
  white-space: normal;
  color: var(--gray-9);
  line-height: var(--font-lineheight-shortest);
  font-weight: var(--font-weight-link);
  font-family: var(--font-family-button);
  text-shadow: 0 1px 2px rgb(255 255 255 / 0.5);
  text-decoration: none;
  text-transform: uppercase;
  background-color: var(--gray-4);
  background-image: linear-gradient(var(--color-background) 0%, var(--gray-4) 100%);
  transition: color 200ms, background 200ms;
}

input[type="submit"]:not(.glb-button):is(:hover, :active) {
  background: linear-gradient(var(--gray-2) 0%, var(--gray-4) 100%);
  color: var(--gray-10);
}

input[type="submit"][disabled]:not(.glb-button) {
  opacity: 0.4;
  cursor: default;
}
input[type="submit"][disabled]:not(.glb-button):hover {
  background-color: var(--gray-4);
  background-image: linear-gradient(var(--white) 0%, var(--gray-4) 100%);
}

/* Adjacent buttons */
input[type="submit"]:not(.glb-button):has(+input[type="submit"]) {
  margin-inline-end: 0.75rem;
}


@media (prefers-color-scheme: dark) {
  /* Keep lightish */
  input[type="submit"]:not(.glb-button) {
    background-color: var(--gray-3);
    background-image: linear-gradient(var(--gray-2) 0%, var(--gray-5) 100%);
    border-color: var(--black);
  }
input[type="submit"]:not(.glb-button):is(:hover, :active) {
    background: var(--gray-3) none;
    border-color: var(--black);
  }
  input[type="submit"][disabled]:not(.glb-button):hover {
    background-color: var(--gray-3);
    background-image: linear-gradient(var(--gray-2) 0%, var(--gray-5) 100%);
  }
}
